import sys
from subprocess import check_output, check_call, CalledProcessError

from helpers import check_legion_created, get_repo_var


def scale(args):
    if len(args) < 1:
        sys.exit("Scale needs a number.")        

    scale = int(args[0])

    # Get all the other arguments for heroku apps:create
    legions_args = args[1:]        

    # Get current repo values
    repo = get_repo_var(scale)

    # Check we ran `legion create` before `scale`
    check_legion_created(repo['heroku_name'])

    for i, worker in enumerate(repo['workers']):
        remote_name = 'legion-%s' % i
        git_url = 'git@heroku.com:%s.git' % worker
        try:
            check_output(['heroku', 'apps:create', worker, '--remote', remote_name] + legions_args)
            check_output(['git', 'push', remote_name, 'master'])
            check_output(['heroku', 'ps:scale', 'web=1', '--app', worker])
        except CalledProcessError:
            # The app already exists, let's just add another remote
            try:
                check_call(['git', 'remote', 'add', remote_name, git_url])
            except CalledProcessError:
                print "Remote %s already exists" % i

    workers = ";".join(["%s.herokuapp.com" % worker for worker in repo['workers']])

    check_output(['heroku', 'config:set', 'WORKERS=%s' % workers, '--app', repo['heroku_name']])
